#!/bin/bash

logfile=logs/log-`date +%Y-%m-%d`
function run {
    leavemealone start "tests de non regression PaStiX" >> $logfile
    echo "people on vulcain"                             >> $logfile 2>&1
    who                                                  >> $logfile 2>&1
    echo "people on hephaistos"                          >> $logfile 2>&1
    ssh hephaistos "leavemealone start \"tests de non regression PaStiX\"" >> $logfile
    ssh hephaistos who                                   >> $logfile 2>&1
    source /opt/env/env_64_mpich2.sh                     >> $logfile 2>&1
    echo vulcain > hostfile
    echo hephaistos  >> hostfile
    mpdallexit                                           >> $logfile 2>&1
    mpdboot -n 2 -f hostfile                             >> $logfile 2>&1
    ./Pastix.pl -Adm                                     >> $logfile 2>&1
    svnversion ../trunk > version.txt
    leavemealone stop                                    >> $logfile
    ssh hephaistos "leavemealone stop"                   >> $logfile
}

# Check if the machine isn't locked
date                                                     > $logfile 2>&1
leavemealone status | grep "is locked" > /dev/null 2>&1
if [ $? -eq 0 ]; then
    leavemealone status                                  >> $logfile 2>&1
else
    ssh hephaistos "leavemealone status" | grep "is locked" > /dev/null 2>&1
    if [ $? -eq 0 ]; then
	ssh hephaistos "leavemealone status" 
    else
	svn up ..                                            >> $logfile 2>&1
	cp $1 Modules/Conf.pm                                >> $logfile 2>&1
	./GenNaturalDocs.pl -y                               >> $logfile 2>&1
        # check if the version file exists
	if [ -f version.txt ]; then
	    #check if the last version was the same
	    echo "comparaison de la version"                 >> $logfile 2>&1
	    cat version.txt | grep `svnversion ../trunk` > /dev/null 2>&1
	    if [ $? -eq 0 ]; then
		echo "Version déjà testée"                   >> $logfile 2>&1
	    else
		run
	    fi
	else
	    run
	fi
    fi
fi