import os
from remoteMachine import RemoteMachine

machines = {}
machinename = u'vulcain.bordeaux.inria.fr-lacoste'
address = u'vulcain.bordeaux.inria.fr'
remote = {
    machinename : RemoteMachine(address,
                                u"lacoste",
                                [u"ssh"],
                                [u"scp"],
                                u'/media/vulcain/lacoste/results',
                                u'bash')
    }

script = u"""
#!/bin/bash

source /opt/intel/Compiler/11.0/083/mkl/tools/environment/mklvarsem64t.sh
source /opt/hwloc/env.sh

cd __DIR__
/opt/mpich2/bin/mpirun -np __PROCNBR__ __CMD__ > __LOG__ 2>&1 
"""
libmkl      = u"-L/opt/intel/Compiler/11.0/083/mkl/lib/em64t/ -lmkl_intel_lp64 -lmkl_sequential -lmkl_core"
libgfortran = u"-lgfortran"

name = u"vulcain-gnu-mpich2-mkl"
machines[name] = remote[machinename].createConfig(name, 
                                                  machinename,
                                                  32, 
                                                  script,
                                                  scotch_home = u"/opt/scotch/",
                                                  metis_int   = u"/opt/metis/",
                                                  metis_int32 = u"/opt/metis/",
                                                  hwloc_home  = u"/opt/hwloc",
                                                  cc          = u"gcc", 
                                                  fc          = u"gfortran", 
                                                  mpicc       = u'/opt/mpich2/bin/mpicc', 
                                                  mpifc       = u'/opt/mpich2/bin/mpif90',
                                                  fcflags     = u'', 
                                                  ccflags     = u'', 
                                                  ccopt       = u'-O3', 
                                                  ccdeb       = u'-g3',
                                                  libblas     = libmkl, 
                                                  libfortran  = libgfortran,
                                                  libmaths    = u'-lm', 
                                                  librt       = u'-lrt',
                                                  ar          = u'ar', 
                                                  arflags     = u'-ruv', 
                                                  make        = u'make', 
                                                  make_j      = u'make -j 8')


script = u"""
#!/bin/bash

source /opt/intel/Compiler/11.0/083/bin/iccvars.sh intel64
source /opt/intel/Compiler/11.0/083/bin/ifortvars.sh intel64
source /opt/intel/Compiler/11.0/083/mkl/tools/environment/mklvarsem64t.sh
source /opt/hwloc/env.sh

cd __DIR__
/opt/mpich2/bin/mpirun -np __PROCNBR__ __CMD__ > __LOG__ 2>&1 
"""
 
name = u'vulcain-intel-mpich2-mkl'
libifcore = u'-L/opt/intel/Compiler/11.0/083/lib/intel64/ -lifcore'
machines[name] = remote[machinename].createConfig(name, 
                                                  machinename,
                                                  32, 
                                                  u"/home/pastix/lacoste/ricar-git",
                                                  script,
                                                  scotch_home = u"/opt/scotch/",
                                                  metis_int   = u"/opt/metis/int",
                                                  metis_int32 = u"/opt/metis/int32",
                                                  hwloc_home  = u"/opt/hwloc",
                                                  cc          = u"/opt/intel/Compiler/11.0/083/bin/intel64/icc", 
                                                  fc          = u"/opt/intel/Compiler/11.0/083/bin/intel64/ifort", 
                                                  mpicc       = u'/opt/mpich2/bin/mpicc -cc=/opt/intel/Compiler/11.0/083/bin/intel64/icc', 
                                                  mpifc       = u'/opt/mpich2/bin/mpif90 -f90=/opt/intel/Compiler/11.0/083/bin/intel64/ifort',
                                                  fcflags     = u'', 
                                                  ccflags     = u'', 
                                                  ccopt       = u'-O3', 
                                                  ccdeb       = u'-g3',
                                                  libblas     = libmkl, 
                                                  libfortran  = libifcore,
                                                  libmaths    = u'-lm', 
                                                  librt       = u'-lrt',
                                                  ar          = u'ar', 
                                                  arflags     = u'-ruv', 
                                                  make        = u'make', 
                                                  make_j      = u'make -j 8')

