MODULE:=matrix_drivers
MY_SRC := skitf.f		\
	  iohb.c		\
	  mmio.c		\
          common_drivers.c	\
	  get_options.c

MY_SRC_MULT_ARCH := read_matrix.c	\
		    rsaread.c		\
		    hbread.c		\
		    mmread.c		\
		    cccread.c		\
		    olafread.c		\
		    chbread.c		\
		    cscdread.c		\
		    peerread.c		\
		    threefilesread.c	\
		    fdupread.c		\
		    laplacian.c

OJTDIR:=$(MODULE)/obj/$(HOSTARCH)
DSTDIR:=$(MODULE)/bin/$(HOSTARCH)
SRCDIR:=$(MODULE)/src
DEPDIR:=$(MODULE)/dep

MY_SRC 		 := $(patsubst %,$(SRCDIR)/%,$(MY_SRC))
MY_SRC_MULT_ARCH := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MULT_ARCH))

MY_OBJ :=  $(patsubst %.c,%.o,$(filter %.c,$(MY_SRC))) 		\
	$(patsubst %.f,%.o,$(filter %.f,$(MY_SRC))) 		\
	$(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 	\
	$(patsubst %.c,%_s.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_d.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_c.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_z.o,$(filter %.c,$(MY_SRC_MULT_ARCH)))

MY_OBJ := $(patsubst $(SRCDIR)/%,$(OJTDIR)/%,$(MY_OBJ))

OBJ_DRIVERS := $(OBJ_DRIVERS) $(MY_OBJ)

DEP_DRIVERS := $(DEP_DRIVERS) $(patsubst $(OJTDIR)/%.$(OBJ),$(DEPDIR)/%.d,$(MY_OBJ))

$(DEPDIR):
	mkdir -p $(DEPDIR)

##
##  General inference rules.
##
$(OBJ_DRIVERS) : $(INCLUDEDIR)/pastix.h $(INCLUDEDIR)/cscd_utils.h

$(OJTDIR)/%_s$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND)$(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -DFORGET_TYPE;
	$(MPCCPROG) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -c $(<) -o $(@) -DFORGET_TYPE

$(OJTDIR)/%_d$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -DFORCE_DOUBLE -DPREC_DOUBLE -DFORGET_TYPE;
	$(MPCCPROG) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -c $(<) -o $(@) -DFORCE_DOUBLE -DPREC_DOUBLE -DFORGET_TYPE

$(OJTDIR)/%_c$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR)  -DFORCE_COMPLEX -DTYPE_COMPLEX -DFORGET_TYPE;
	$(MPCCPROG) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -c $(<) -o $(@) -DFORCE_COMPLEX -DTYPE_COMPLEX -DFORGET_TYPE

$(OJTDIR)/%_z$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -DFORCE_DOUBLE -DPREC_DOUBLE -DFORCE_COMPLEX -DTYPE_COMPLEX -DFORGET_TYPE; 
	$(MPCCPROG) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) -c $(<) -o $(@) -DFORCE_DOUBLE -DPREC_DOUBLE -DFORCE_COMPLEX -DTYPE_COMPLEX -DFORGET_TYPE

$(OJTDIR)/%$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR)  $(CCTYPESFLT);
	$(MPCCPROG) $(CCOPT) $(COMMON_FLAGS) -I$(INCLUDEDIR) $(CCTYPESFLT) -c $(<) -o $(@)

$(OJTDIR)/%$(OBJ)	:       $(SRCDIR)/%.f config.in
	echo "$@ $(patsubst $(DEPDIR)/%,$(OJTDIR)/%,$(patsubst %.d,%$(OBJ),$@)) : $<" > $@
	$(CFPROG) -c $< -o $@

