MODULE:=sopalin

MY_SRC:= bordi.c		\
	sopalin_thread.c

MY_SRC_MULT_ARCH := 	sopalin3d.c		\
			sopalin_init.c		\
			sopalin_option.c	\
			pastix.c		\
			ooc.c			\
			debug_dump.c		\
			csc_intern_io.c		\
			csc_intern_compute.c	\
			csc_intern_build.c	\
			csc_intern_solve.c	\
			csc_intern_updown.c	\
			tools.c			\
			coefinit.c		\
			sopalin_init.c		\
			debug_dump.c		\
			csc_intern_io.c		\
			csc_intern_compute.c	\
			csc_intern_build.c	\
			csc_intern_solve.c	\
			csc_intern_updown.c	\
			ooc.c			\
			sopalin3d.c		\
			pastix.c		\
			pastix_fortran.c	\
			cscd_utils.c		\
			csc_utils.c		\
			cscd_utils_fortran.c

MY_SRC_FACT_TYPE := sopalin3d.c

MY_SRC_MURGE 		:= murge_fortran.c murge.c	
MY_SRC_MURGE_MULT_ARCH  := 



OJTDIR:=$(MODULE)/obj/$(HOSTARCH)
DEPDIR:=$(MODULE)/dep
SRCDIR:=$(MODULE)/src

MY_SRC 		 := $(patsubst %,$(SRCDIR)/%,$(MY_SRC))
MY_SRC_MULT_ARCH := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MULT_ARCH))
MY_SRC_FACT_TYPE := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_FACT_TYPE))

MY_SRC_MULT_ARCH := $(MY_SRC_MULT_ARCH) 		\
	$(MY_SRC_FACT_TYPE)				\
	$(patsubst %.c,%_lu.c,$(MY_SRC_FACT_TYPE))	\
	$(patsubst %.c,%_ldlt.c,$(MY_SRC_FACT_TYPE))	

MY_OBJ :=  $(patsubst %.c,%.o,$(filter %.c,$(MY_SRC))) 		\
	$(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 	\
	$(patsubst %.c,%_s.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_d.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_c.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) \
	$(patsubst %.c,%_z.o,$(filter %.c,$(MY_SRC_MULT_ARCH)))
MY_OBJ := $(patsubst $(SRCDIR)/%,$(OJTDIR)/%,$(MY_OBJ))

OBJ_LIB := $(OBJ_LIB) $(MY_OBJ)
DEP_LIB := $(DEP_LIB) $(patsubst $(OJTDIR)/%.o,$(DEPDIR)/%.d,$(MY_OBJ))

MY_SRC_MURGE 		:= $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MURGE))
MY_SRC_MURGE_MULT_ARCH  := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MURGE_MULT_ARCH))

MY_OBJ := $(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MURGE))) 		\
	$(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_s.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_d.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_c.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_z.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))
MY_OBJ := $(patsubst $(SRCDIR)/%,$(OJTDIR)/%,$(MY_OBJ))

OBJ_MURGE := $(OBJ_MURGE) $(MY_OBJ)
DEP_MURGE := $(DEP_MURGE) $(patsubst $(OJTDIR)/%.o,$(DEPDIR)/%.d,$(MY_OBJ))

include all_mp_rules.mk

$(OJTDIR)/sopalin3d$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN $(CCTYPESFLT) -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN $(CCTYPESFLT) -DNO_TYPE_PREFIX
$(OJTDIR)/sopalin3d_s$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN
$(OJTDIR)/sopalin3d_d$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC)  -DCHOL_SOPALIN -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_DOUBLE
$(OJTDIR)/sopalin3d_c$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_COMPLEX
$(OJTDIR)/sopalin3d_z$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_DOUBLE -DFORCE_COMPLEX

$(OJTDIR)/sopalin3d_lu$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU $(CCTYPESFLT) -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU $(CCTYPESFLT) -DNO_TYPE_PREFIX
$(OJTDIR)/sopalin3d_lu_s$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU
$(OJTDIR)/sopalin3d_lu_d$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU -DFORCE_DOUBLE
$(OJTDIR)/sopalin3d_lu_c$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  -DSOPALIN_LU -DFORCE_COMPLEX
$(OJTDIR)/sopalin3d_lu_z$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU -DFORCE_DOUBLE -DFORCE_COMPLEX

$(OJTDIR)/sopalin3d_ldlt$(OBJ)	:	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) $(CCTYPESFLT)  -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  $(CCTYPESFLT)  -DNO_TYPE_PREFIX
$(OJTDIR)/sopalin3d_ldlt_s$(OBJ):	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC);
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@
$(OJTDIR)/sopalin3d_ldlt_d$(OBJ):	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE
$(OJTDIR)/sopalin3d_ldlt_c$(OBJ):	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_COMPLEX
$(OJTDIR)/sopalin3d_ldlt_z$(OBJ):	$(SRCDIR)/sopalin3d.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE -DFORCE_COMPLEX

MURGE_FORTRAN_INC = common_pastix.h

$(SRCDIR)/murge_fortran.c	:	murge/include/murge.h			\
					$(SRCDIR)/murge_pastix_fortran.c	\
					murge/scripts/geninterface.pl
	-$(RM) $@
	for f in $(MURGE_FORTRAN_INC) ; do			\
		echo "#include \""$${f}"\"" >> $@;		\
	done
	echo "#ifdef FORCE_NOMPI"   >> $@
	echo "#include \"nompi.h\"" >> $@
	echo "#else		  " >> $@
	echo "#include <mpi.h>	  " >> $@
	echo "#endif              " >> $@
	murge/scripts/geninterface.pl -f $< >> $@
	cat sopalin/src/murge_pastix_fortran.c  >> $@

$(OJTDIR)/murge_fortran$(OBJ)	:	$(SRCDIR)/murge_fortran.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) $(CCTYPESFLT) -DNO_TYPE_PREFIX ;
	$(MPCCPRG) $(CCOPT) $(CCINC) $(CCTYPESFLT) -DNO_TYPE_PREFIX -c $< -o $@ 
