/* Copyright 2008 BORDEAUX I UNIVERSITY & INRIA 
**
** This file is part of the PaStiX parallel sparse matrix package.
**
** This software is governed by the CeCILL-C license under French law
** and abiding by the rules of distribution of free software. You can
** use, modify and/or redistribute the software under the terms of the
** CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
** URL: "http://www.cecill.info".
** 
** As a counterpart to the access to the source code and rights to copy,
** modify and redistribute granted by the license, users are provided
** only with a limited warranty and the software's author, the holder of
** the economic rights, and the successive licensors have only limited
** liability.
** 
** In this respect, the user's attention is drawn to the risks associated
** with loading, using, modifying and/or developing or reproducing the
** software by the user in light of its specific status of free software,
** that may mean that it is complicated to manipulate, and that also
** therefore means that it is reserved for developers and experienced
** professionals having in-depth computer knowledge. Users are therefore
** encouraged to load and test the software's suitability as regards
** their requirements in conditions enabling the security of their
** systems and/or data to be ensured and, more generally, to use and
** operate it in the same conditions as regards security.
** 
** The fact that you are presently reading this means that you have had
** knowledge of the CeCILL-C license and that you accept its terms.
*/
extern "C"
{

#   define char_arg( a ) a
#   define char_arg_decl char*
#   define __stdcall


#ifdef BLAS_DOUBLE
#ifdef CPLX
#define AXPY                        zaxpy_
#define GEMM                        zgemm_
#define GEMV                        zgemv_
#define TRSM                        ztrsm_
#define POF                         zpof_
#define PPF                         zppf_
#define GER                         zgeru_
#define SYR                         zher_
#define COPY                        zcopy_
#define SCAL                        zscal_
#else /* CPLX */
#define AXPY                        daxpy_
#define GEMM                        dgemm_
#define GEMV                        dgemv_
/*#define GEAM                        dgema_
  #define GESM                        dgems_*/
/*#define GECP                        dgecp_*/
#define SYMM                        gsymm_
#define TRSM                        dtrsm_
/*#define GEF                         dgef_*/
/*#define POF                         dpof_*/
/*#define PPF                         dppf_*/
#define GER                         dger_
/*#define GETMO                       dgetmo_*/
#define SYR                         dsyr_
#define SPR                         dspr_
#define SYRK                        dsyrk_
#define COPY                        dcopy_
#define SCAL                        dscal_
/*#define V_DIV                       dv_div_*/
#define POTRF                       dpotrf_
#define POTF2                       dpotf2_
#endif /* CPLX */
#else /* BLAS_DOUBLE */
#ifdef CPLX
#define AXPY                        caxpy_
#define GEMM                        cgemm_
#define GEMV                        cgemv_
#define TRSM                        ctrsm_
#define GER                         cgeru_
#define SYR                         cher_
#define COPY                        ccopy_
#define SCAL                        cscal_
#else /* CPLX */
#define AXPY                        saxpy_
#define GEMM                        sgemm_
#define GEMV                        sgemv_
/*#define GEAM                        sgema_
  #define GESM                        sgems_*/
/*#define GECP                        sgecp_*/
#define SYMM                        ssymm_
#define TRSM                        strsm_
/*#define GEF                         sgef_*/
/*#define POF                         spof_*/
/*#define PPF                         sppf_*/
#define GER                         sger_
/*#define GETMO                       sgetmo_*/
#define SYR                         ssyr_
#define SPR                         sspr_
#define SYRK                        ssyrk_
#define COPY                        scopy_
#define SCAL                        sscal_
/*#define V_DIV                       sv_div_*/
#define POTRF                       spotrf_
#define POTF2                       spotf2_
#endif /* CPLX */
#endif

}

extern "C" {

extern void AXPY( INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT* ) ;  
extern void GEMM( char_arg_decl, char_arg_decl, INT*, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT* ) ;  
extern void GEMV( char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT* ) ;  
/*extern void GEAM( char_arg_decl,  char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT * ) ;  
  extern void GESM( char_arg_decl,  char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT * ) ;  */
/*extern void GECP( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
extern void SYMM( char_arg_decl, char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT* ) ;  
extern void TRSM( char_arg_decl, char_arg_decl, char_arg_decl, char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT* ) ;  
/*extern void GEF( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
/*extern void POF( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
/*extern void PPF( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
extern void GER( INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT*, FLOAT[], INT* ) ;  
/*extern void GETMO( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
extern void SYR( char_arg_decl, INT*, FLOAT*, FLOAT[], INT*, FLOAT[], INT* ) ;  
extern void SPR( char_arg_decl, INT*, FLOAT*, FLOAT[], INT*, FLOAT[] ) ;  
extern void SYRK( char_arg_decl, INT*, INT*, FLOAT*, FLOAT[], INT*, FLOAT*, FLOAT[], INT* ) ;  
extern void COPY( INT*, FLOAT[], INT*, FLOAT[], INT* ) ;  
extern void SCAL( INT*, FLOAT*, FLOAT[], INT* ) ;  
/*extern void V_DIV( char_arg_decl, INT*, FLOAT*, FLOAT*, INT*, FLOAT*, INT* ) ;  */
extern void POTRF( char_arg_decl, INT*, FLOAT[], INT*, INT* ) ;  
extern void POTF2( char_arg_decl, INT*, FLOAT[], INT*, INT* ) ;  

}

#define SOPALIN_LACPY(m, n, A, lda, B, ldb)                     \
  {                                                             \
    INT k;                                                      \
    for (k=0; k<(n); k++)                                       \
      {                                                         \
        SOPALIN_COPY(m, &(A[k*lda]), iun, &(B[k*ldb]), iun);    \
      }                                                         \
  }

#define SOPALIN_AXPY(n,a,x,ix,y,iy) { INT n1=n;FLOAT a1=a; INT ix1=ix; INT iy1=iy; AXPY(&n1,&a1,x,&ix1,y,&iy1); }
#define SOPALIN_GEMV(i,m,n,x,a,u,b,v,y,c,w) { INT m1=m; INT n1=n; FLOAT x1=x; INT u1=u; INT v1=v; FLOAT y1=y; INT w1=w; GEMV(i,&m1,&n1,&x1,a,&u1,b,&v1,&y1,c,&w1); }

void dim_dgeam(char *transa,char *transb,INT m,INT n,FLOAT alpha,FLOAT *a, INT lda,FLOAT *b,INT ldb);
/*
void dim_dgeam(char *transa,char *transb,INT m,INT n,FLOAT alpha,FLOAT *a,
	       INT lda,FLOAT *b,INT ldb)
{
  INT i;
  
  if (*transa=='N')
    {
      if (*transb=='N')
	for (i=0;i<n;i++)
#ifdef CPLX
	  {SOPALIN_AXPY(m,alpha,(FLOAT *) &(a[i*lda]),1, (FLOAT *) &(b[i*ldb]),1);}
#else
          {SOPALIN_AXPY(m,alpha,&(a[i*lda]),1,&(b[i*ldb]),1);}
#endif
      else
	for (i=0;i<n;i++)
#ifdef CPLX
	  {SOPALIN_AXPY(m,alpha,(FLOAT *) &(a[i*lda]),1, (FLOAT *) &(b[i]),ldb);}
#else
          {SOPALIN_AXPY(m,alpha,&(a[i*lda]),1,&(b[i]),ldb);}
#endif
    }
  else
    {
      if (*transb=='N')
	for (i=0;i<n;i++)
#ifdef CPLX
	  {SOPALIN_AXPY(m,alpha,(FLOAT *) &(a[i]),lda, (FLOAT *) &(b[i*ldb]),1);}
#else
          {SOPALIN_AXPY(m,alpha,&(a[i]),lda,&(b[i*ldb]),1);}
#endif
      else
	for (i=0;i<n;i++)
#ifdef CPLX
	  {SOPALIN_AXPY(m,alpha,(FLOAT *) &(a[i]),lda, (FLOAT *) &(b[i]),ldb);}
#else
          {SOPALIN_AXPY(m,alpha,&(a[i]),lda,&(b[i]),ldb);}
#endif
    }
}
*/

/* Pb pas de truc d'addition C=A+B */
/*#define SOPALIN_GEAM(i,j,m,n,x,a,u,b,v) { INT m1=m; INT n1=n; FLOAT x1=-x; INT u1=u; INT v1=v; GEAM(i,j,&m1,&n1,&x1,a,&u1,&x1,b,&v1,b,&v1); }*/
#define SOPALIN_GEAM(i,j,m,n,x,a,u,b,v) dim_dgeam(i,j,m,n,x,a,u,b,v)

/* Pb pas de truc de soustraction C=A-B */
/*#define SOPALIN_GESM(i,j,m,n,x,a,u,b,v) { INT m1=m; INT n1=n; FLOAT x1=-x; INT u1=u; INT v1=v; GESM(i,j,&m1,&n1,&x1,a,&u1,&x1,b,&v1,b,&v1); }*/
#define SOPALIN_GESM(i,j,m,n,x,a,u,b,v) dim_dgeam(i,j,m,n,-(x),a,u,b,v)

#define SOPALIN_COPY(n,x,u,y,v) { INT n1=n; INT u1=u; INT v1=v; COPY(&n1,x,&u1,y,&v1); }

#define SOPALIN_SCAL(n,a,x,u) { INT n1=n; FLOAT a1=a; INT u1=u; SCAL(&n1,&a1,x,&u1); }

#define SOPALIN_PPF(a,n,f)  PPF(a,n,f)

#define SOPALIN_TRSM(s,p,t,d,m,n,x,a,u,b,v) { INT m1=m; INT n1=n; FLOAT x1=x; INT u1=u; INT v1=v; TRSM(s,p,t,d,&m1,&n1,&x1,a,&u1,b,&v1); }

#define BLAS_GEMM

#define SOPALIN_GEMM(i,j,m,n,k,x,a,u,b,v,y,c,w) { INT m1=m; INT n1=n; INT k1=k; FLOAT x1=x; INT u1=u; INT v1=v; FLOAT y1=y; INT w1=w; GEMM(i,j,&m1,&n1,&k1,&x1,a,&u1,b,&v1,&y1,c,&w1); }

#ifndef CPLX
#define SOPALIN_SYR(i,n,x,a,u,b,v) { INT n1=n; FLOAT x1=x; INT u1=u; INT v1=v; SYR(i,&n1,&x1,a,&u1,b,&v1); }
#else
#define SOPALIN_SYR(i,n,x,a,u,b,v) { INT n1=n; FLOAT x1=x; INT u1=u; INT v1=v; GER(&n1,&n1,&x1,a,&u1,a,&u1,b,&v1); }
#endif

#define SOPALIN_GER(m,n,x,a,u,b,v,c,w)  { INT m1=m; INT n1=n; FLOAT x1=x; INT u1=u; INT v1=v; INT w1=w; GER(&m1,&n1,&x1,a,&u1,b,&v1,c,&w1); }

#define SOPALIN_POF  POF

